//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  ^C}[eXg
//  TThreadgp
//  ʃXbhŃ^C}[𓮍삳DtH[ړ\XV
//
//  Junki쐬̃R[h𗘗p
//  TvvOW[002_Av̋NԂ𑪒]̃XgbvEHb`
//  pă^C}[ɂ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2008N1010 J
//  2012N0428 sCPUgp㏸Ă܂ۂ
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows XP(SP3) + Delphi XE Pro
//  Windows 7 U64   + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit TimerTestUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, plJStopWatch, Spin;

type
  TplTimerThread = class(TThread)
  private
    { Private 錾 }
    AStopWatch : TplJStopWatch;
    FPanel     : TPanel;
    FTimeValue : Integer;
    FTimeStart : Extended;
    FTimeDis   : Extended;
    procedure DisplayTime;
    procedure ChangeEnabled;
  protected
    procedure Execute; override;
  public
    constructor Create(TimeValue: Integer; Panel: TPanel); Virtual;
    destructor Destroy; override;    
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    SpinEdit1: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    AThread : TplTimerThread;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  Xbh쐬Ďs
//  ^C}[̋N⎞Ԍo߂̊Ď̓Xbhōs
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
  Button1.Enabled := False;

  AThread := TplTimerThread.Create(SpinEdit1.Value, Panel1);
end;

//=============================================================================
//  ^C}[Xgbv
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
begin
  if Assigned(AThread) then AThread.Terminate;
end;

{ TplTimerThread }

//=============================================================================
//  XbhĎs
//=============================================================================
constructor TplTimerThread.Create(TimeValue: Integer; Panel: TPanel);
begin
  FPanel     := Panel;
  FTimeValue := TimeValue;

  inherited Create(False);
  FreeOnTerminate := True;
end;

//=============================================================================
//  Xbhj鎞ɂ̓XgbvEHb`j
//=============================================================================
destructor TplTimerThread.Destroy;
begin
  FreeAndNil(AStopWatch);
  inherited Destroy;
end;

//=============================================================================
//  ^C}[NĎԌo߂\
//=============================================================================
procedure TplTimerThread.Execute;
begin
  if not Assigned(AStopWatch) then AStopWatch := TplJStopWatch.Create(nil);

  FTimeStart := AStopWatch.Start;

  while not Terminated do begin
    FTimeDis := FTimeValue - (AStopWatch.Time - FTimeStart) / 1000;
    Synchronize(DisplayTime);

    if FTimeDis <= 0 then break;

    //ꂪȂCPUgpˏオ
    Sleep(1);
  end;

  //Sȓ̂߂ɂSynchronizegp
  //Form1.Button1.Enabled := True;
  Synchronize(ChangeEnabled);
  Terminate;
  Windows.Beep(200, 1200);
end;

//=============================================================================
//  c莞Ԃ𕪂ƕbŕ\D\͂̃XbhďovO
//  FTimeDis̒l͕b
//=============================================================================
procedure TplTimerThread.DisplayTime;
var
  Amin : Integer;
  Asec : Integer;
begin
  Amin := Trunc(FTimeDis / 60);
  Asec := Trunc(FTimeDis) - Amin * 60;
  FPanel.Caption := Format('c%4d%2db', [Amin, Asec]);
  FPanel.Update;
end;

//=============================================================================
//  XbhOւ̃ANZX
//=============================================================================
procedure TplTimerThread.ChangeEnabled;
begin
  Form1.Button1.Enabled := True;
end;

end.
