//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  ^C}[eXg
//  DelphiTStopWatch gp^C}[  Delphi 2010ȍ~@@
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N0428 J
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows XP(SP3) + Delphi XE Pro
//  Windows 7 U64   + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit TimerTestUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Spin, Diagnostics;

type
  TplTimerThread = class(TThread)
  private
    { Private 錾 }
    AStopWatch : TStopWatch;
    FPanel     : TPanel;
    FTimeValue : Int64;
    FTimeDis   : Int64;
  protected
    procedure Execute; override;
  public
    constructor Create(TimeValue: Int64; Panel: TPanel); Virtual;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    SpinEdit1: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    AThread : TplTimerThread;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  Xbh쐬Ďs
//  ^C}[̋N⎞Ԍo߂̊Ď̓Xbhōs
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
  Button1.Enabled := False;
  AThread := TplTimerThread.Create(SpinEdit1.Value, Panel1);
end;

//=============================================================================
//  ^C}[Xgbv
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
begin
  if Assigned(AThread) then AThread.Terminate;
end;

{ TplTimerThread }

//=============================================================================
//  XbhĎs
//=============================================================================
constructor TplTimerThread.Create(TimeValue: Int64; Panel: TPanel);
begin
  FPanel     := Panel;
  FTimeValue := TimeValue;

  inherited Create(False);
  FreeOnTerminate := True;
end;

//=============================================================================
//  ^C}[NĎԌo߂\
//  DelphiTStopWatchgp(usesDiagnosticsKv)
//
//  Panel1TheadCreatëɂĂ邪CForm1͒ڃR[hɏĂ
//  XbhŁCĂяõXbh̃Rg[̃ANZXKvł
//  ΁CCreatëR[h^ɂ@l
//
//  TStopWatch̎gpɂ́CusesDiagnosticsKv
//=============================================================================
procedure TplTimerThread.Execute;
var
  Amin : Integer;
  Asec : Integer;
begin
  AStopWatch := TStopwatch.StartNew;

  while not Terminated do begin
    //FTimeDis̒l͕b
    FTimeDis := FTimeValue - AStopWatch.ElapsedMilliseconds div 1000;

    //c莞Ԃ𕪂ƕbŕ\
    Synchronize(
      procedure
      begin
        Amin := FTimeDis div 60;
        Asec := FTimeDis - Amin * 60;
        FPanel.Caption := Format('c%4d%2db', [Amin, Asec]);
        FPanel.Update;
      end
    );

    if FTimeDis <= 0 then break;

    //ꂪȂCPUgpˏオ
    Sleep(1);
  end;

  //Sȓ̂߂ɂSynchronizegp
  Synchronize(
    procedure
    begin
      Form1.Button1.Enabled := True;
    end
  );
  Terminate;
  Windows.Beep(200, 1200);
end;

end.
