//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  ^C}[eXg
//  DelphiTStopWatchCreateAnonymousThreadgp^C}[  Delphi XEȍ~@@
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N0428 J
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows XP(SP3) + Delphi XE Pro
//  Windows 7 U64   + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit TimerTestUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Spin, Diagnostics;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    SpinEdit1: TSpinEdit;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    flgStop : Boolean;
    TimerThread : TThread;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  CreateAnonymousThreadŃXbh쐬Ďs
//  ^C}[̋N⎞Ԍo߂̊Ď̓Xbhōs
//
//  TStopWatch̎gpɂ́CusesDiagnosticsKv
//  TThread.Synchronize͕svmȂ
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  AStopWatch : TStopWatch;
  FTimeValue : Int64;
  FTimeDis   : Int64;
  Amin       : Integer;
  Asec       : Integer;
begin
  Button1.Enabled := False;

  if Assigned(TimerThread) then begin
    flgStop := True;
    TimerThread.Terminate;
    FreeAndNil(TimerThread);
  end;

  flgStop := False;
  TimerThread := TThread.CreateAnonymousThread(
    procedure()
    begin
      AStopWatch := TStopwatch.StartNew;
      FTimeValue := SpinEdit1.Value;

      while True do begin
        //FTimeDis̒l͕b
        FTimeDis := FTimeValue - AStopWatch.ElapsedMilliseconds div 1000;
        Amin     := FTimeDis div 60;
        Asec     := FTimeDis - Amin * 60;

        TThread.Synchronize(TThread.CurrentThread,
          procedure
          begin
            Panel1.Caption := Format('c%4d%2db', [Amin, Asec]);
            Panel1.Update;
          end
        );

        if flgStop       then break;
        if FTimeDis <= 0 then break;

        //ꂪȂCPUgpˏオ
        Sleep(1);
      end;

      //̏I...
      TThread.Synchronize(TThread.CurrentThread,
        procedure
        begin
          Button1.Enabled := True;
          Windows.Beep(200, 1200);
        end
      );
    end
  );
  TimerThread.FreeOnTerminate := False;
  TimerThread.Start;
end;

//=============================================================================
//  ^C}[Xgbv
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
begin
  flgStop := True;
end;

end.
