//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  IsbN2020JEg_E^C}[
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2014N0721 `
//  2014N0725 `
//  2015N1008 
//    E~ZRh̒l؂̂ĂĂ1bȂl\Ă̂C
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit TokyoOlympic2020TimerUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    class var
      FFormatSettings: TFormatSettings;
  public
    { Public declarations }
    TimerThread : TThread;
    fgStop : Boolean;
  end;

var
  Form1: TForm1;

implementation

uses DateUtils, plGetAge;

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  fgStop  := False;
  Caption := 'IsbN 2020 JEg_E^C}[';

  Panel2.Font.Name := 'MS UI Gothic';
  Panel2.Font.Size := 17;
  Panel2.Alignment := taCenter;
  Panel2.Caption   := '2021N̓IsbNJ܂';

  Panel1.Font.Name := 'MS UI Gothic';
  Panel1.Font.Size := 17;
  Panel1.Alignment := taCenter;

  Button1Click(nil);
end;

//=============================================================================
//  tH[鎞̏
//=============================================================================
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Assigned(TimerThread) then begin
    fgStop := True;
    TimerThread.Terminate;
    FreeAndNil(TimerThread);
  end;
end;

//=============================================================================
//  cvZĕ\
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LStartDateTime : TDateTime;
  LEndDateTime   : TDateTime;
  LYear          : Integer;
  LMonth         : Integer;
  LDays          : Integer;
  LDecodeHour    : WORD;
  LDecodeMin     : WORD;
  LDecodeSec     : WORD;
  LDecodeMilli   : WORD;
  LTimeBetween   : TDateTime;
  LText          : String;
begin
  FFormatSettings := TFormatSettings.Create;
  FFormatSettings.ShortDateFormat := 'YYYY/MM/DD';

  if Assigned(TimerThread) then begin
    TimerThread.Terminate;
    FreeAndNil(TimerThread);
  end;

  TimerThread := TThread.CreateAnonymousThread(
    procedure()
    begin
      while True do begin

        if fgStop then break;

        LYear  := 0;
        LMonth := 0;
        LDays  := 0;
        LDecodeHour  := 0;
        LDecodeMin   := 0;
        LDecodeSec   := 0;
        LDecodeMilli := 0;

        //StartDateTimeEndDateTiem܂łvZ
        LEndDateTime   := StrToDateTime('2021/7/23 20:00:00');
        LStartDateTime := Now;
        if LStartDateTime < LEndDateTime then begin

          //ŏ̎傫ꍇ́C܂1o߂ĂȂ̂őOƂ
          if Frac(LStartDateTime) > Frac(LEndDateTime) then begin
            LEndDateTime := DateUtils.IncDay(LEndDateTime, -1);
          end;

          //EndDateTiem܂ł̔NCCvZ
          plGetAge.GetAge(LStartDateTime,
                          LEndDateTime,
                          LYear,
                          LMonth,
                          LDays,
                          True);

          //oߎԂZoāCCCbɕ
          LTimeBetween := LEndDateTime - LStartDateTime;
          DecodeTime(LTimeBetween, LDecodeHour, LDecodeMin, LDecodeSec, LDecodeMilli);
          //~ZRh͍lȂ
          if LDecodeMilli > 0 then begin
            LDecodeSec := LDecodeSec + 1;
          end;

          //ʂ\
          TThread.Synchronize(TThread.CurrentThread,
            procedure
            begin
              if LYear = 0 then begin
                LText :=   IntToStr(LMonth) + ' '
                         + IntToStr(LDays)  + ' '
                         + IntToStr(LDecodeHour)  + ' '
                         + IntToStr(LDecodeMin)   + ' '
                         + IntToStr(LDecodeSec)   + 'b';
                if LMonth = 0 then begin
                  LText :=   IntToStr(LDays)  + ' '
                           + IntToStr(LDecodeHour)  + ' '
                           + IntToStr(LDecodeMin)   + ' '
                           + IntToStr(LDecodeSec)   + 'b';
                  if LDays = 0 then begin
                    LText :=   IntToStr(LDecodeHour)  + ' '
                             + IntToStr(LDecodeMin)   + ' '
                             + IntToStr(LDecodeSec)   + 'b';
                    if LDecodeHour = 0 then begin
                      LText :=   IntToStr(LDecodeMin)   + ' '
                               + IntToStr(LDecodeSec)   + 'b ';
                      if LDecodeMin = 0 then begin
                        LText := IntToStr(LDecodeSec)   + 'b';
                        if LDecodeSec = 0 then exit;
                      end;
                    end;
                  end;
                end;
                Panel1.Caption := LText;
              end else begin
                Panel1.Caption :=   IntToStr(LYear)  + 'N '
                                  + IntToStr(LMonth) + ' '
                                  + IntToStr(LDays)  + ' '
                                  + IntToStr(LDecodeHour)  + ' '
                                  + IntToStr(LDecodeMin)   + ' '
                                  + IntToStr(LDecodeSec)   + 'b';
              end;
            end
          );
          Sleep(1);
        end else begin
          Panel1.Caption := 'JEg_E͏I܂';
        end;
      end;
    end
  );
  TimerThread.FreeOnTerminate := False;
  TimerThread.Start;
end;

end.
